# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free

Name:           clirr
Summary:        Binary and Source Compatibility Check
Url:            http://clirr.sourceforge.net/
Version:        0.6
Release:        6%{?dist}
Epoch:          0
License:        LGPL
Group:          Development/Libraries/Java
Source0:        http://prdownloads.sourceforge.net/clirr/clirr-0.6-src.zip

Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        clirr-0.6-jpp-depmap.xml
Source5:        clirr-core-0.6.pom
Source6:        clirr-maven-0.6.pom

Patch0:         clirr-0.6-maven-plugin-project_xml.patch
# patch to bcel-5.2
Patch1:         clirr-0.6-BcelJavaType.patch
Patch2:         clirr-0.6-maven-maven_xml.patch
#Patch3:         clirr-0.6-core-project_xml.patch

BuildRequires:  jpackage-utils >= 0:5.0.0
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  junit
BuildRequires:  saxon
BuildRequires:  saxon-scripts
BuildRequires:  maven >= 0:1.1
BuildRequires:  maven-plugins-base
BuildRequires:  maven-plugin-changes
BuildRequires:  maven-plugin-developer-activity
BuildRequires:  maven-plugin-file-activity
BuildRequires:  maven-plugin-jdepend
BuildRequires:  maven-plugin-jxr
BuildRequires:  maven-plugin-license
BuildRequires:  maven-plugin-linkcheck
BuildRequires:  maven-plugin-multiproject
BuildRequires:  maven-plugin-tasklist
BuildRequires:  maven-plugin-test
BuildRequires:  maven-plugin-xdoc
BuildRequires:  maven-model
BuildRequires:  sf-javaapp-maven-plugin
BuildRequires:  bcel5.3
BuildRequires:  apache-commons-cli
BuildRequires:  jakarta-commons-jelly
BuildRequires:  apache-commons-lang
#
Requires:       java >= 0:1.6.0
Requires:       bcel5.3
Requires:       apache-commons-cli
Requires:       jakarta-commons-jelly
Requires:       apache-commons-lang
%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot
Requires(post):    jpackage-utils >= 0:5.0.0
Requires(postun):  jpackage-utils >= 0:5.0.0

%description
Clirr is a tool that checks Java libraries for binary and 
source compatibility with older releases. Basically you 
give it two sets of jar files and Clirr dumps out a list 
of changes in the public api. The Clirr Ant task can be 
configured to break the build if it detects incompatible 
api changes. In a continuous integration process Clirr 
can automatically prevent accidental introduction of 
binary or source compatibility problems.

%package maven-plugin
Summary:        Maven plugin for %{name}
Group:          Development/Build Tools
Requires:       %{name} = %{epoch}:%{version}
Requires:       maven >= 0:1.1
Requires:       maven-model
Requires:       sf-javaapp-maven-plugin

%description maven-plugin
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if 0
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.
%endif

%prep
%setup -q -n %{name}-%{version}
chmod -R go=u-w *
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
#%patch3 -b .sav3

if [ ! -f %{SOURCE4} ]; then
export DEPCAT=$(pwd)/clirr-0.6-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > clirr-0.6-depmap.new.xml
fi

%build
export LANG=C
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

MAVEN_HOME_LOCAL=$(pwd)/.maven
maven -Dmaven.repo.remote=file:/usr/share/maven/repository \
      -Dmaven.home.local=${MAVEN_HOME_LOCAL} \
      -Dmaven.javadoc.source=1.4 \
      -Dgoal=jar:jar,dist,javadoc:generate \
      multiproject:goal

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -m 644 core/target/%{name}-core-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-core-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# plugin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven/plugins
install -m 644 \
    maven/target/%{name}-maven-%{version}.jar \
    $RPM_BUILD_ROOT%{_datadir}/maven/plugins/maven-clirr-plugin-%{version}.jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/maven-plugins
pushd $RPM_BUILD_ROOT%{_javadir}/maven-plugins
ln -sf \
    %{_datadir}/maven/plugins/maven-clirr-plugin-%{version}.jar \
    maven-clirr-plugin.jar
popd

%add_to_maven_depmap %{name} %{name}-core %{version} JPP %{name}

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE5} \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-clirr-core.pom
install -m 644 %{SOURCE6} \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-clirr-maven.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core
cp -pr core/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core
rm -rf core/target/docs/apidocs
#install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/maven
#cp -pr maven/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/maven
#rm -rf maven/target/docs/apidocs
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
%if 0
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/core
cp -pr core/target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/core
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/maven
cp -pr maven/target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/maven
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post maven-plugin
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun maven-plugin
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root)
%doc LICENSE.txt
%{_javadir}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-core-%{version}.jar.*
%endif

%files maven-plugin
%defattr(-,root,root)
%doc LICENSE.txt
%{_datadir}/maven/plugins/maven-clirr-plugin*.jar
%{_javadir}/maven-plugins/maven-clirr-plugin.jar
%{_datadir}/maven2/poms/JPP-clirr-maven.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/maven-%{name}-plugin-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%if 0
%files manual
%defattr(-,root,root)
%{_docdir}/%{name}-%{version}
%endif

%changelog
* Tue Sep 07 2010 Ralph Apel <r.apel at r-apel.de> 0:0.6-6
- Amend clirr-core pom

* Sun Sep 05 2010 Ralph Apel <r.apel at r-apel.de> 0:0.6-5
- Omit -manual
- Only -maven-plugin runtime requires maven
- do -javadoc for core only and without maven

* Fri May 08 2009 Ralph Apel <r.apel at r-apel.de> 0:0.6-4.jpp5
- First JPP-5 release

* Mon Nov 05 2007 Ralph Apel <r.apel at r-apel.de> 0:0.6-3jpp
- Rebuild to replace SRPM-as-noarch in repo
- Add missing BRs according to mock check-rebuild

* Thu Jul 05 2007 Ralph Apel <r.apel at r-apel.de> 0:0.6-2jpp
- Add depmap frag
- Fix mixed use of tabs and spaces
- Patch to bcel-5.2 and (B)R it
- Fix aot build
- Improve poms
- Install maven1 plugin to /usr/share/maven/plugins
- Make unversioned symlink in /usr/share/java/maven-plugins

* Wed Sep 20 2006 Ralph Apel <r.apel at r-apel.de> 0:0.6-1jpp
- First release
- Add gcj_support option
- Add post/postun Requires for javadoc

